<?php
// Heading
$_['heading_title'] = 'Verifone Hosted';

// Text
$_['text_extension'] = 'Extensions';
$_['text_success'] = 'Success: You have modified Verifone account details!';
$_['text_edit'] = 'Edit your Verifone Hosted settings';
$_['text_general_settings'] = 'General settings';
$_['text_production_credentials'] = 'Production credentials';
$_['text_test_credentials'] = 'Test credentials';
$_['text_payment_options'] = 'Payment options';
$_['text_advanced_options'] = 'Advanced options';
$_['text_order_statuses'] = 'Order statuses';
$_['text_verifone_hosted'] = '<a href="https://www.verifone.com" target="_blank">
<img src="view/image/payment/verifone_logo.png" alt="Verifone logo"  title="Verifone" /></a>';

// Entry
//general
$_['entry_region'] = 'Region';
$_['entry_region_help'] = 'Select which region you are based in. Contact your Verifone representative if you are not sure.';
$_['entry_total'] = 'Total';
$_['entry_total_help'] = 'The checkout total the order must reach before this payment method becomes active.';
$_['entry_test'] = 'Test Mode';
$_['entry_test_help'] = 'Place a test order';
$_['entry_order_status'] = 'Order Status';
$_['entry_order_status_help'] = 'Choose order status for a complete order';
$_['entry_geo_zone'] = 'Geo Zone';
$_['entry_geo_zone_help'] = 'Geo Zone that the payment is visible';
$_['entry_status'] = 'Status';
$_['entry_status_help'] = 'Enables or disables the payment method';
$_['entry_sort_order'] = 'Sort Order';
$_['entry_sort_order_help'] = 'Sort order that the payment is displayed to client';

//prod
$_['entry_prod_api_user'] = 'Api User';
$_['entry_prod_api_user_help'] = 'Please enter the Api User';
$_['entry_prod_api_key'] = 'Api Key';
$_['entry_prod_api_key_help'] = 'Please enter the Api Key';
$_['entry_prod_entity'] = 'Entity ID ';
$_['entry_prod_entity_help'] = 'This is provided by a Verifone employee';
$_['entry_prod_payment_contract'] = 'Payment Contract Id';
$_['entry_prod_payment_contract_help'] = 'This is provided to you by a Verifone employee. It can also be found in the Verifone portal by navigating to the Payment Provider Contract menu underneath Admin. From the URL grab the ID formatted like xxx-xxx-xxx-xxxx';
$_['entry_prod_3ds_contact'] = '3DS Contract Id';
$_['entry_prod_3ds_contact_help'] = 'This is provided by a Verifone employee.';

//test
$_['entry_test_api_user'] = 'Test Api User';
$_['entry_test_api_user_help'] = 'Please enter the Api User.';
$_['entry_test_api_key'] = 'Test Api Key';
$_['entry_test_api_key_help'] = 'Please enter the Api Key';
$_['entry_test_entity'] = 'Test Entity ID ';
$_['entry_test_entity_help'] = 'This is provided by a Verifone employee.';
$_['entry_test_payment_contract'] = 'Test Payment Contract Id';
$_['entry_test_payment_contract_help'] = 'This is provided to you by a Verifone employee. It can also be found in the Verifone portal by navigating to the Payment Provider Contract menu underneath Admin. From the URL grab the ID formatted like xxx-xxx-xxx-xxxx';
$_['entry_test_3ds_contact'] = 'Test 3DS Contract Id';
$_['entry_test_3ds_contact_help'] = 'This is provided by a Verifone employee.';

//payment
$_['entry_3ds'] = 'Use 3DS';
$_['entry_3ds_help'] = 'Enables or disables 3D-Secure for all payments.';
$_['entry_cvv'] = 'CVV on payment';
$_['entry_cvv_help'] = 'Requires the CVV  when shoppers pay with a card.';

//advance
$_['entry_enable_curl'] = 'Enable/Disable cURL verify host and peer';
$_['entry_enable_curl_help'] = 'This option determines whether curl verifies the authenticity of the peer and host certificates';
$_['entry_enable_overlay'] = 'Enable/Disable overlay when placing order ';
$_['entry_enable_overlay_help'] = 'This option will enable an overlay when placing an order. This is nothing more than a visual indication for the user that the request is starting';


// Error
$_['error_permission'] = 'Warning: You do not have permission to modify payment Verifone!';
$_['error_required_field'] = ' field is required!';

$_['text_refund'] = 'Refund';
$_['text_total_amount_refund'] = 'Initial amount that can be refunded: ';
$_['text_amount_refunded'] = ' refunded';
$_['text_refund_final'] = 'Refunded';
